# Markdown Monster Tip of the Day

## Markdown Monster Shortcut Keys
Here are a few useful Markdown Monster shortcuts to remember:

* F12 - Toggle Preview Pane
* Shft-F12 - Preview in Browser
* Ctl-Shift-B - Toggle Sidebar
* Alt-Shift-Enter - Distraction Free Mode
* F11 - Toggle Presentation Mode
* Alt-G - Open Git Window
* Alt-Z - Toggle Word Wrap

### Addins
Did you know you can create Markdown Monster Add-ins using .NET Code? Addins can interact with or create docs, modify & inject content & override Markdown rendering. You can interact w/ UI, create menu items, UI components and windows.

Find out more: https://markdownmonster.west-wind.com/docs/_4ne0s0qo…

### Markdown Link Spaces
Tip: When embedding images or links into Markdown it's best not to use spaces for file names.

While @markdownmonstr can handle spaces in links fine they're UrlEncoded and hard to read & edit.

Better to use CamelCase or SnakeCase for files w\ long names.

https://markdownmonster.west-wind.com

## Open from Url
Did you know that Markdown Monster can open Markdown documents from a Url?

Use the *File -> Open -> Open from Url*.

MM understands and fixes up common Urls from Github, BitBucket, Gists, Microsoft Docs and a few other places.

https://markdownmonster.west-wind.com #markdown
  
## Drag Tabs into other Editors?
Did you know that you can grab a Markdown Monster Tab and drag into another application that accepts files? You can drag your document into VS Code or Visual Studio for example and open it there.

## Favorites Tab Dragging
Did you know that in Markdown Monster you can drag a tab into the Favorites sidebar? Favorites let you bookmark and organize common files and folders in a convenient list, and now you can more easily add Favorites by simply dragging an open tab into the Favorites sidebar. 

Simply grab the tab and drag it into the Favorites sidebar at the position you want.

## Star the GitHub Repo
Do you use Markdown Monster? Like using it? If you do please consider starring the Github repo to show your support. 

Stars help project visibility, bring more interaction, feature discussions & yes even bug reports all of which make MM better.


## Open Markdown Monster from the Command Line
Did you know you can open Markdown Monster from the command line with:

mm .

to open the current folder in the folder browser, or:

mm filename.md

to open a file from the current folder? You can specify multiple files, use full paths or relative paths and specify either files or folders (only one folder though).

https://markdownmonster.west-wind.com/docs/_4x313dneu.htm

## Quickly Open the Folder Browser
Did you know you can quickly open the active file's folder in the Folder Browser by clicking the location icon in the Folder Browser toolbar, or `Show in Folder Browser` in the tab context menu?

It's a quick way to navigate and work with files in the current folder.

## Open Markdown Files from Preview HTML Links
Did you know that in Markdown Monster you can click on Markdown links in the Previewer to open related Markdown documents in the Editor? MM  intercepts relative or local file Markdown links and opens the appropriate Markdown document in the editor. 

## Image Linking
Did you know you have many choices for creating Markdown links in Markdown Monster?

* Ctrl-K link dialog
* Ctrl-Shift-K inline linking
* raw Markdown links
* raw HTML links

Inline linking is a new, much requested feature.

markdownmonster.west-wind.com/docs/_4xs10gau… #markdown #documentation

## Edit Images
Did you know you can bring up your favorite image editor directly from your Markdown Document in Markdown Monster?

Right click on an image link in the editor and choose 'Edit Image' to open the image in your selected editor. The editor can be configured in Settings and finds common editors by default.

## Convert to Word Document
Did you know you can use the PanDoc addin to easily create a Word document from your Markdown files? Use the Addin Manager to add the PanDoc addin then use Convert Markdown Document and select the Docx export. 

## Generate HTML Output
Did you know Markdown Monster has a lot of ways to generate HTML output? Save As HTML can save as a single packaged HTML file, or as HTML with loose Assets or just raw output. You can View in Browser and Save As from there, or you can simple select some or all Markdown and use File->Copy As HTML to copy the HTML to the clipboard.

## Generate PDFs from your Markdown Topics
Did you know you can generate a PDF file from your Markdown documents in Markdown Monster with just a couple of clicks? Use File -> Save as PDF.

## Custom Preview Themes
Did you know that you can easily create custom preview themes in Markdown Monster? 

Copy an existing preview theme folder then customize the HTML and CSS to match your specific site designs or preferences. New themes show up in the theme selector.

https://markdownmonster.west-wind.com/docs/_4nn17bfic.htm

## Distraction Free Mode
Did you know you can use Distraction Free mode in Markdown Monster to zoom the editor? Click on the Zoom icon in the window toolbar on the top right or ALT-SHIFT-ENTER to toggle. Also configurable via `DistractionFreeModeHideOptions`. #markdown
https://video.twimg.com/tweet_video/DUu5z0gVQAA0dGt.mp4

## Viewer Mode
Did you know you can zoom the HTML preview in Markdown Monster? Press F11 or click on the full screen icon in the upper right window corner to toggle full screen mode to read through long documents. #markdown
https://video.twimg.com/tweet_video/DUgIJB_U0AMomcE.mp4

## Right Click To Edit Images, Links and Tables
Did you know you can right click on Image tags to preview or edit the image in your favorite image editor? You can also right click on a table and open the table editor, on a link and edit and update or remove the link.

## Using Gists for Bug Reports and general Purpose Web Pages
Did you know that Github Gists support Markdown? You can use Gist to create one off HTML pages in Markdown. They're great for posting detailed bug reports or ideas that you can link on Twitter and other social media. Markdown Monster's Gist Integration Addin can also help with editing and updating and managing of Gists easily.

## 3 ways to Image Embedding
Did you know there are a ton of ways to get images into Markdown Monster: 

1. Type image Markdown
2. Paste images from clipboard
3. Embed with Image Dialog
4. Drag from Explorer
5. Drag from Folder Browser
6. Built-in Screen Capture

https://markdownmonster.west-wind.com/docs/_4s01ezteq.htm #markdown

## FontAwesome Icons
Did you know that you can easily embed FontAwesome icons into Markdown documents with @MarkdownMonstr? Simply embed @icon-iconname into your documents and MM renders the icon for you. For more sophisticated use cases you can also use raw HTML.

## Snippet Add-in
Did you know the Snippet Addin can turn an expansion key into expanded text? Turn short phrases like `fa-` into an expanded font-awesome HTML string, turn `datetime` into a properly formatted date and time,  turn `signature` into your name, company and logo signature. It's easy...

## Portable Version 
Did you know you can install Markdown Monster's portable version on a USB drive and run it on any machine?

![](https://raw.githubusercontent.com/RickStrahl/MarkdownMonster/main/MarkdownMonsterWeb/Images/ScreenShots/PortableVersionUSBFolder.png)

## Pasting Images into Content
Did you know Markdown Monster can paste images from the clipboard into your Markdown documents? 

Capture to the clipboard from Web browsers, Windows Screen capture or the built-in screen capture and paste images into the editor. MM prompts for a filename and  embeds it into the document. 

Images are auto-compressed to reduce image size.


## Build your own Markdown Monster Add-ins
Did you know that Markdown Monster has an add-in extension model? You can easily create an add-in that adds custom functionality to Markdown Monster. You can add a button and window using your own UI and/or simply interact with the active document, hook events such when documents are loaded or saved, and modify selected text inside of a document. It's easy to do using the .NET Add-in model.

## Document Outline
Did you know Markdown Monster has a Document Outline you can use to quickly view & jump to sections of the document?

Use the Bookmark icon on the left panel or Tools->View->Document Outline (alt-v-o). Great for navigation or quick review of large docs.


## Html Editing
Did you know that Markdown Monster can also edit HTML files with live preview? Open an HTML document and MM will preview it and update the preview as you edit it.

## Backup your Markdown Monster Settings
Have you backed up your Markdown Monster Settings lately? There are quite a few settings for MM and Addins and it's a good idea to take a snapshot of your settings.

Use Tool->Settings->Backup to  easily back up to:

* Zip File
* Folder
